/*********************************************************************
 * 
 *    Filename:  cpad.h
 *    Author:    Ryan Shillington <shillington@writeme.com>
 *  
 *     This program is free software; you can redistribute it and/or
 *     modify it under the terms of the GNU General Public License as
 *     published by the Free Software Foundation; either version 2 of
 *     the License, or (at your option) any later version.
 *
 ********************************************************************/

#ifndef CPAD_H
#define CPAD_H

// Setup the debug ability
#ifndef NET_DEBUG
#define NET_DEBUG 1
#define DEBUG(n, args...) if (NET_DEBUG >= (n)) fprintf(stderr, args)
#endif /* NET_DEBUG */

#define WRITE(n, args...) sprintf(output, args); \
  write(n, output, strlen(output));

// Set the maximum size of IR data transfer
#define RX_BUF_SIZE 376
#define TX_BUF_SIZE 376

// Set my DLC address
#define CPAD_ADDR 0xCCCBABE

// Function to figure out how to service a request from a client
void serviceRequest(char request[RX_BUF_SIZE], char data[TX_BUF_SIZE]);

//* A helper function to read IP addresses out of a char stream
void readIP(char *data, byte ip[4]);

/* FUNCTIONS FOR SPECIFIC REQUESTS (GETTING INFORMATION) */
void serviceTemperature(char data[TX_BUF_SIZE]);
void serviceMemory(char data[TX_BUF_SIZE]);
void serviceLoad(char data[TX_BUF_SIZE]);
void serviceChangeIP(char id, char data[TX_BUF_SIZE]);

/* FUNCTIONS FOR SPECIFIC REQUESTS (SETTING ATTRIBUTES) */
void serviceSetIP(char request[RX_BUF_SIZE]);

/* THIS FUNCTION SERVICES EXECUTING A SPECIFIC COMMAND */
void serviceExecute(char *request, char data[TX_BUF_SIZE]);

#endif // CPAD_H
